<?php

if (!class_exists('IMWB_Covert_Messenger_PROUpdate'))
{
	class IMWB_Covert_Messenger_PROUpdate
	{
		/**
		 * Instance Variables
		 */

		var $updateURL = 'http://covertmessenger.com/plugin_update/pro/update.txt';
		var $checkTime = 43200; // seconds
		var $updateOptionName;
		var $latestVersion;
		var $update = array();

		/**
		 * PHP 4 constructor (for backwards compatibility)
		 *
		 * @param	void
		 * @return	bool	true
		 */

		function IMWB_Covert_Messenger_PROUpdate($plugin_name)
		{
			$this->__construct($plugin_name);
			return;
		}


		/**
		 * PHP 5 constructor
		 *
		 * @param	void
		 * @return	void
		 */

		function __construct($plugin_name)
		{
			// Default to Current Version
			$this->latestVersion = IMWB_CIM_PRO_VERSION;

			// Set Update Option Name
			$this->updateOptionName = $plugin_name.'_update_check';

			// Check For An Update
			$this->lastUpdateCheck();
		}


		function getUpdateInfo($afterPluginRow=0)
		{

			$result = wp_remote_get($this->updateURL, $requestArgs);

			// Error? Die and Display Error Message
			if(is_wp_error($result))
			{
				return false;
			}

			// Valid Authentication
			if($result['response']['code']=='200')
			{
				// Store Update Information
				$update = explode("\n", $result['body']);
				for($i=0; $i < sizeof($update); $i++)
				{
					list($key,$value) = explode('|||', $update[$i]);
					if(isset($key) && strlen(trim($key)) > 0) { $this->update[trim($key)] = trim($value); }
				}

				// Update Last Checked
				$this->update['last_checked'] = @date('Y-m-d H:i:s');

				// Set Legacy Variables
				$this->latestVersion = $this->update['latest_version'];

				// Update Options
				update_option($this->updateOptionName, $this->update);

				// After Plugin Row
				if($afterPluginRow && ($this->update['latest_version'] > IMWB_CIM_PRO_VERSION))
					$this->afterPluginRow();
					
				return true;
			}
			
			return false;
		}


		function afterPluginRow()
		{
			$display = $this->update['after_plugin_row'];

			// Latest Version
			$display = str_replace('%latest-version%', $version, $display);

			// Display Update Message
			echo '<tr class="plugin-update-tr"><td colspan="3" class="plugin-update"><div class="update-message">'.$display.'</td></tr>';

		}


		function lastUpdateCheck()
		{
			// Get Options
			$this->getOptions();

			// Last Update Check
			if( @strtotime(@date('Y-m-d H:i:s')) > (@strtotime($this->update['last_checked']) + $this->checkTime) )
			{
				$this->getUpdateInfo();
			}
		}


		function getOptions()
		{
			// Last Update Check
			$this->update = get_option($this->updateOptionName);

			if(!$this->update)
			{
				// Get Latest Update Information
				$this->getUpdateInfo();

				// Create New Option
				$this->update = array('last_checked'=>@date('Y-m-d H:i:s'), 'latest_version'=>$this->latestVersion);
				add_option($this->updateOptionName, $this->update);
			}
		}


		function getLatestVersion()
		{
			return($this->update['latest_version']);
		}
	}
}

?>